/***************************************************************************
 *   Copyright (C) 2005 by Alejandro Alviña y Gonzalo Saavedra            *
 *   gfss@elo.utfsm.cl o cerebro@elo.utfsm.cl                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <cstdlib>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdio.h>
#include <signal.h>
#include "hijo.h"
#include "manipulad.h"

#define MAX_dato 50

using namespace std;

pid_t pid;
int status;
Hijo *hijo_ping; //objeto ping
Hijo *hijo_scilab; //objeto scilab (o matlab si se deseara cambiar... SE CAMBIO)
ManipulaD *datosxy; //objeto para los puntos o datos

static void final(int) //Se cierran todos los procesos abiertos, borrando los objetos
{
    printf("\tEspere mientras se cierra...\n");
    sleep(10);
    waitpid(pid, &status, 0);
    delete hijo_ping;
    delete hijo_scilab;
    delete datosxy;
    raise(SIGTERM);
    //return;
}

void  err_sys(char * msg) 
{
     printf("%s \n", msg);
     exit(-1); 
}


int main(int argc, char *argv[])
{

    int i;
    float z;
    //cadenas auxiliares o para llamar algun proceso
    char *cadena;
    char cadenaux[64];
    char cadenaping [100];
    char cadenafft[50];

    if (signal(SIGINT, final)==SIG_ERR)
     err_sys("No se puede recibir la seal de termino.");

    printf("\tDesplegando las graficas.\n\tPara terminar presione: Ctrl + c\n");   
    
    cadena = NULL;
    strcpy(cadenaping, "ping");//para llamar a ping
    
    //se ingresan los flags que se le entregaron a gping, que corresponden a los mismos de ping
    for(i=1;i<argc;i++){
        sprintf(cadenaping, "%s %s",cadenaping, argv[i]);
	}
    

	
    //se crea el proceso ping	
    hijo_ping = new Hijo(cadenaping, "r");

    //Se crea el proceso matlab
    hijo_scilab = new Hijo("matlab -nodesktop -nosplash 1>/dev/null 2>/dev/null", "w");
    
    //Para los datos, intermediario
    datosxy = new ManipulaD(MAX_dato);

    //comienza el traspaso de datos
    while(1){
    if(cadena != NULL) delete cadena; //borra el espacio que se le asigno anteriormente
    
    cadena = hijo_ping->leer(); //se obtienen de ping la ultima salida estandar
    datosxy->obt_xy(cadena); //se agregan los ultimos datos adquiridos
    sprintf(cadenafft,"t=-25:24;\n"); //para entregar formateada a scilab
    
    //Se comienza a entregar datos al scilab
    hijo_scilab->escribir(cadenafft);
    hijo_scilab->escribir("x= [");
    
    for ( i= 0; i<MAX_dato; i++){
        sprintf(cadenaux,"%f ",datosxy->x[i]);
        hijo_scilab->escribir(cadenaux);
        }
    hijo_scilab->escribir("];\n");

    hijo_scilab->escribir("y= [");
    for ( i= 0; i<MAX_dato; i++){
        sprintf(cadenaux,"%f ",datosxy->y[i]);
        hijo_scilab->escribir(cadenaux);// other data could be sent here 
        }
    hijo_scilab->escribir("];\n");
    
    hijo_scilab->escribir("z=abs(fft(y))';\n");//obtiene el fft, valor absoluto 
    hijo_scilab->escribir("subplot(2,1,1);\n");//divide la pantalla en dos y dibuja en el primero
    hijo_scilab->escribir("plot(x,y);\n");//dibuja el tiempo de demora vs muestra
    hijo_scilab->escribir("title('Ping en el tiempo.');");
    hijo_scilab->escribir("ylabel('Tiempo[ms]');\n");//TITULO
    hijo_scilab->escribir("xlabel('Muestras');\n");
    hijo_scilab->escribir("subplot(2,1,2);\n");//se hubica en el segundo grafico
    hijo_scilab->escribir("plot(t,z);\n");//dibuja la fft
    hijo_scilab->escribir("title('FFT del ping.');");//TITULOS
    hijo_scilab->escribir("xlabel('Frecuencia');");
    hijo_scilab->escribir("ylabel('Ganancia');\n");

    
    }//fin del while
    
}
